#!/usr/bin/env python

import os

class IndexEntry:
    def __init__(self, line, module=False):
        if module or '(module)' in line:
            i = line.rfind('">')
            j = line.rfind('</tt></tt>')
            if j == -1:
                j = line.rfind('</tt>')
            line = line[i+2:j]
            self.word = line
            self.ttword = line + " (module)"
            self.url = 'module-' + line.replace('_','-') + '.html'
            return

        # else...
        
        i = line.find('')
        if i == -1:
            raise ValueError

        url0 = line[:i]
        
        j = line.find('###')
        if j == -1:
            raise ValueError
        self.ttword = line[i+1:j].replace('()','')
        j = self.ttword.find('>')
        self.word = self.ttword[j+1:].lower()
        
        k = self.ttword.rfind(' ')
        module = self.ttword[k+1:-1]
        k = url0.find('#')
        l = url0.find('">')
        self.url = 'module-%s.html%s'%(module, url0[k:l])
        self.url = self.url.replace('_','-') 
        if len(module) > 0 and module[0] == '(':
            i = url0.find('"')
            self.url = url0[i+1:-2]

    def __cmp__(self, other):
        return cmp(self.word, other.word)

    def __repr__(self):
        return '\n<a href="%s">%s</a>\n'%(self.url, self.ttword)
        

def gen(input='index.dat', output='genindex.html', module=False):
    if not os.path.exists(output):
        print "Creating %s"%output
        os.system('touch %s'%output)

    if not os.path.exists(input):
        return

    data = []
    for X in open(input).xreadlines():
        try:
            data.append(IndexEntry(X, module=module))
        except ValueError:
            pass
    data.sort()
    left = '&nbsp&nbsp&nbsp;'
    I = left + ('<br>' + left).join([str(z) for z in data])

    out = open(output).read()
    j = out.find('</h2>')
    if j != -1:
        i = j + 5
    else:
        i = 0

    W = out[:i] + I + out[i:]

    open(output,'w').write(W)

################################
# do it


gen('index.dat','genindex.html', module=False)
gen('modindex.dat','modindex.html', module=True)

